'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _html = require('./html');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import {serverRendering} from './server-rendering'

// TODO(vjpr): How to make this hot-reloadable for dev?
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var isDev = _ref2.isDev,
        publicDir = _ref2.publicDir,
        title = _ref2.title,
        routes = _ref2.routes,
        store = _ref2.store,
        webpackAssets = _ref2.webpackAssets,
        useServerSideRendering = _ref2.useServerSideRendering,
        loadingComponent = _ref2.loadingComponent,
        externalCss = _ref2.externalCss;
    var js, css, props, el, msg;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            js = getJs({ isDev: isDev, webpackAssets: webpackAssets, publicDir: publicDir });
            css = getCss({ isDev: isDev, webpackAssets: webpackAssets, publicDir: publicDir, externalCss: externalCss });

            if (useServerSideRendering) {
              _context.next = 8;
              break;
            }

            props = {
              js: js,
              css: css,
              store: store,
              title: title,
              loadingComponent: loadingComponent
            };
            el = _react2.default.createElement(_html.Html, (0, _extends3.default)({}, props, {
              component: _react2.default.createElement('div', null)
            }));
            return _context.abrupt('return', '<!doctype html>\n' + _server2.default.renderToString(el));

          case 8:
            msg = 'Server-side rendering not implemented yet.';

            console.warn(msg);
            return _context.abrupt('return', msg);

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

function getJs(_ref3) {
  var isDev = _ref3.isDev,
      webpackAssets = _ref3.webpackAssets,
      publicDir = _ref3.publicDir;


  var assets = getAssets({ publicDir: publicDir });

  var externals = [
  // TODO(vjpr): This was hack during extraction.
  assets.leafletJs.local];

  var bundles = [webpackAssets.vendor && webpackAssets.vendor.js, webpackAssets.main.js];

  var out = externals.concat(bundles).filter(Boolean);

  return out;
}

function getCss(_ref4) {
  var _externalCss;

  var webpackAssets = _ref4.webpackAssets,
      publicDir = _ref4.publicDir,
      externalCss = _ref4.externalCss;


  var assets = getAssets({ publicDir: publicDir });

  externalCss = externalCss || [];

  (_externalCss = externalCss).push.apply(_externalCss, [
    // NOTE: Originally this came before main bundle css. The more you know.
    // TODO(vjpr): This was hack during extraction.
    //assets.leafletCss.local,
  ]);

  // Will be undefined in dev/debug.
  var bundles = [webpackAssets.vendor && webpackAssets.vendor.css, webpackAssets.main.css];

  var out = externalCss.concat(bundles).filter(Boolean);

  return out;
}

// TODO(vjpr): This is intranav specific. Remove it.
function getAssets(_ref5) {
  var publicDir = _ref5.publicDir;

  var cdn = '//cdnjs.cloudflare.com/ajax/libs/';
  return {
    leafletCss: {
      local: (0, _path.join)(publicDir, '/leaflet.css')
    },
    leafletJs: {
      local: (0, _path.join)(publicDir, '/leaflet-src.js'),
      cdn: 'http://cdn.leafletjs.com/leaflet-0.7.3/leaflet-src.js'
    },
    bootstrapCss: {
      local: (0, _path.join)(publicDir, '/bootstrap.css'),
      cdn: cdn + 'twitter-bootstrap/3.3.5/css/bootstrap.css'
    },
    fontAwesomeCss: {
      local: (0, _path.join)(publicDir, '/font-awesome.min.css'),
      cdn: cdn + 'font-awesome/4.3.0/css/font-awesome.min.css'
    }
  };
}
module.exports = exports['default'];
//# sourceMappingURL=render-app-html.js.map
